package com.example.cxfrs;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import java.util.Calendar;

@Path("/v1/foo")
public class EmployeeServiceResource {
    public EmployeeServiceResource() { }

    @GET
    public Response encryptSingle(@QueryParam("text") String text) {
        Calendar time = Calendar.getInstance();
        if (text == null || text.isEmpty()) {
            return Response
                    .status(Response.Status.BAD_REQUEST)
                    .entity(new ResponseMap("bad request", "bad input: call with ?text=foo", time))
                    .type(MediaType.APPLICATION_JSON_TYPE)
                    .build();
        }
        return Response.ok(new ResponseMap("ok", "hello "+ text, time), MediaType.APPLICATION_JSON_TYPE).build();
    }

    @JsonSerialize()
    @JsonInclude(JsonInclude.Include.NON_EMPTY)
    public final static class ResponseMap {
        String status;
        String result;
        Calendar time;

        public ResponseMap(final String status, final String result) {
            this(status, result, null);
        }

        public ResponseMap(final String status, final String result, final Calendar time) {
            this.status = status;
            this.result = result;
            this.time = time;
        }

        public String getResult() {
            return result;
        }

        public String getStatus() {
            return status;
        }

        public Calendar getTime() {
            return time;
        }
    }

}